var Webfeeler = new Object();

// Initialize the toggle feature of the toolbar
var toolbarToggleExpanded		= false;
var TOOLBAR_COLLAPSED 			= 30;
var TOOLBAR_EXPANDED 			= 90;
var TOOLBAR_MORE 				= "More...";
var TOOLBAR_LESS				= "Less";

// This is what we look for to see if it was an error that was returned
var ERR_START 					= '300';

var ALERT_BEG					= "Webfeeler: ";


// Instatiate services
const WF_PrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
const WF_Branch = WF_PrefService.getBranch("webfeeler.");

//Pref Alias
var WF_Pref_gen_toolbar	= "gen.toolbar";
var WF_Pref_gen_alert = "gen.alert";
var WF_Pref_trans_use_default_language = "trans.use_default_language";
var WF_Pref_trans_translation_state = "trans.translation_state";
var WF_Pref_trans_language_location = "trans.language_location";
var WF_Pref_trans_language_name = "trans.language_name";
var WF_Pref_emboss_port = "emboss.port";
var WF_Pref_save_dest = "save.dest";
var WF_Pref_save_filepre = "save.filepre";
var WF_Pref_save_filesuf = "save.filesuf";


Webfeeler.initialize = function() {
    try {
        /*
         *  Get a Foo component
         */
        var obj = this.getWfObj();
        
        /*  This is a note from SIMILE
         *  Initialize it. The trick is to get past its IDL interface
         *  and right into its Javascript implementation, so that we
         *  can pass it the LiveConnect "java" object, which it will
         *  then use to load its JARs. Note that XPCOM Javascript code
         *  is not given LiveConnect by default.
         */
        if (!obj.wrappedJSObject.initialize(java, true)) {
            alert(obj.wrappedJSObject.error);
        }
    } catch (e) {
        this._fail(e);
    }
};

Webfeeler.save = function() {
    //this.startProgressMeter();
    //document.getElementById('WF-progressmeter').mode = 'undetermined';
    this.toToolbar("Translating and saving the contents of " + window._content.document.location);		
    try {
        var obj = this.getWfObj();
        var webfeeler = obj.wrappedJSObject.getWFObj();
        var dest = WF_Branch.getCharPref(WF_Pref_save_dest);
        var filePrefix = WF_Branch.getCharPref(WF_Pref_save_filepre);
        var fileSuffix = WF_Branch.getCharPref(WF_Pref_save_filesuf);
		var state = WF_Branch.getIntPref(WF_Pref_trans_translation_state);
        var result = webfeeler.save(window._content.document.location, dest, filePrefix, fileSuffix, state);
        if(result.substring(0,3) == ERR_START) {
        	this._trace("Unable to save the translated contents of " + window._content.document.location + " to " + dest +".  Please visit http://www.igudo.com/firefox/webfeeler for documentation.");
       		this._trace(result);
       		this.out(result+" Unable to save the translated contents of " + window._content.document.location + " to " + dest +".  Please visit http://www.igudo.com/firefox/webfeeler for documentation.");
        }
        else {
        	this._trace(result);
        	this.out("The translated contents of " + window._content.document.location + " have been saved to " + result);
      	}
    } catch (e) {
        this._fail(e);
    }
    //this.stopProgressMeter();
};

Webfeeler.print = function() {
    	//this.startProgressMeter();
    	this.toToolbar("Embossing the contents of " + window._content.document.location);
    try {
        var obj = this.getWfObj();
        var webfeeler = obj.wrappedJSObject.getWFObj();
        var port = WF_Branch.getCharPref(WF_Pref_emboss_port);
		var state = WF_Branch.getIntPref(WF_Pref_trans_translation_state);
        var result = webfeeler.print(window._content.document.location, port, state);
        //this.stopProgressMeter();
        // Was an error code returned?
        if(result.substring(0,3) == ERR_START) {
        	this._trace("Unable to emboss the contents of " + window._content.document.location + ". Please visit http://www.igudo.com/firefox/webfeeler for documentation.");
			this._trace(result);
			this.out("Unable to emboss the contents of " + window._content.document.location + ". Please visit http://www.igudo.com/firefox/webfeeler for documentation. "+result);

        }
        else {
        	this._trace(result);
         	this.out("The translated contents of " + window._content.document.location + " have been sent to your embosser on port " + port + " .");       	
       }
    } catch (e) {
        this._fail(e);
    }
};

Webfeeler.options = function() {
	window.open("chrome://webfeeler/content/options.xul")
}


Webfeeler.toggleHeight = function() {
	var toolbar = document.getElementById("WF-toolbar");
	var toolbarExpandButton = document.getElementById("WF-toolbar-button-expand");
	
	if (toolbarToggleExpanded) {
		toolbar.height = TOOLBAR_COLLAPSED;
		toolbarExpandButton.label = TOOLBAR_MORE;
		toolbarToggleExpanded = false;
	} else {
		toolbar.height = TOOLBAR_EXPANDED;
		toolbarExpandButton.label = TOOLBAR_LESS;
		toolbarToggleExpanded = true;
	}
}

Webfeeler.out = function(msg) {
	this.toToolbar(msg);
	this.toAlert(msg);
}

Webfeeler.toToolbar = function(msg) {
	// print to console
	var console = document.getElementById("WF-toolbar-textbox");
	console.value = msg;
}

Webfeeler.toAlert = function(msg) {
	// print to alert (if applicable)
	var sendAlert = WF_Branch.getBoolPref(WF_Pref_gen_alert);
	if (sendAlert) {
		alert(ALERT_BEG+msg);
	}
}

Webfeeler.startProgressMeter = function() {
	document.getElementById('WF-progressmeter').mode = 'undetermined';
}

Webfeeler.stopProgressMeter = function() {
	document.getElementById('WF-progressmeter').mode = 'determined';
}

Webfeeler.getWfObj = function() {
    return Components.classes["@webfeeler/util;1"]
        .getService(Components.interfaces.nsIHelloWorld);
}

Webfeeler._trace = function (msg) {
    Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(msg);
            

}

Webfeeler._fail = function(e) {
    var msg;
    if (e.getMessage) {
        msg = e + ": " + e.getMessage() + "\n";
        while (e.getCause() != null) {
            e = e.getCause();
            msg += "caused by " + e + ": " + e.getMessage() + "\n";
        }
    } else {
        msg = e;
    }
    alert(msg);
};
